org.eclipse.viatra.query.runtime.matchers.util

## Enum Direction

- java.lang.Object
- - java.lang.Enum<Direction>
  - - org.eclipse.viatra.query.runtime.matchers.util.Direction

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<Direction>

      public enum Direction
      extends java.lang.Enum<Direction>

  Indicates whether a propagated update event signals the insertion or deletion of an element

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `DELETE`
    `INSERT`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `char` | `asSign()`
    `Direction` | `multiply(Direction other)` Returns the direction that is the product of this direction and the other direction.
    `Direction` | `opposite()`
    `static Direction` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static Direction[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### INSERT

          public static final Direction INSERT

    - #### DELETE

          public static final Direction DELETE

  - ### Method Detail

    - #### values

          public static Direction[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Direction c : Direction.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Direction valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### opposite

          public Direction opposite()

      Since:
        2.4

    - #### asSign

          public char asSign()

      Since:
        2.4

    - #### multiply

          public Direction multiply(Direction other)

      Returns the direction that is the product of this direction and the other direction. DELETE x DELETE = INSERT DELETE x INSERT = DELETE INSERT x DELETE = DELETE INSERT x INSERT = INSERT
      Since:
        2.4